#include <assert.h>
#include "ezwin.h"
#include "bitmap.h"
#include <cstring>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>

using namespace std;
// haven't decided the dimensions
SimpleWindow game("iSnake",10.0 ,10.0 , Position( , ));
SimpleWindow menu("iSnake", , , Position( , ));
SimpleWindow exitwindow("Exit", , , Position( , ));
SimpleWindow gameover("Gave Over", , , Position( , ));


/* Variable Description
 
 snake   : represents the snake
 HS      : stores the highscores
 map	 : represents the map, stores info about the maze, fruits etc;
 lives	 : represents the lives remaining for the snake
 level	 : represents the current level in the game
 length  : represents the length of the snake
 direc	 : represents the direction of the snake
 score	 : represents the current score in the game
 levelscore : rperesents the score in the current level
 xfruit	 : represents the x coordinate of the fruit
 yfruit	 : represents the y coordinate of the fruit
 xbonusfruit : represents the x coordinate of the bonus fruit
 ybonusfruit : represents the y coordinate of the bonus fruit
 lengthinc : used to represent if snake has eaten the fruit
 
 */
struct snakebody
{
	int x;
	int y;
}snake[40];
int HS[5];
int map[20][20]; // havent decided the dimensions of the map
int lives;
int level;
int length;
char direc;
int score=0;
int levelscore=0;
int xfruit;
int yfruit;
int xbonusfruit;
int ybonusfruit;
int lengthinc=0;



// bitmaps declaration

BitMap head(game);
BitMap body(game);
BitMap fruit(game);
BitMap bonusfruit(game);
BitMap wall(game);
BitMap life(game);
BitMap nolife(game);

BitMap background(menu);
BitMap newgame(menu);
BitMap highscore(menu);
BitMap help(menu);
BitMap credit(menu);
BitMap quit(menu);
BitMap yes(exitwindow);
BitMap no(exitwindow);
BitMap back(menu);
BitMap instructions(menu);
BitMap credits(menu);
BitMap go(gameover);
Bitmap y(gameover);
Bitmap n(gameover);

/* Function Description
 
 HSload	       : loads the highscores onto the HS array
 loadmenu	   : loads the bitmap in the menu window
 mainmenu	   : handles the mouse clicks on the main menu
 mainmenuclick : handles the mouse click in the main menu
 HSdisplay	   : displays the highscores
 loadinstructions : displays the instructions 
 loadcredits   : displays the credits
 exitmenu	   : used to quit the game
 exitwindowclick : handles the mouse click in the exit menu
 loadgame	   : loads the bitmaps 	
 playgame	   : start the game	
 load		   : prepares the level	
 loadmap	   : loads the map coordinates
 plotfruit	   : plots the fruits randomly
 genrandom	   : generates random numbers
 endgame	   : end the game
 convert	   : converts integer into string
 cheakscore	   : checks if the score is a highscore
 gameoverclick : handles the mouse click in the gameover window
 turn		   : loads the appropriate head bitmap
 gamewindowclick : handles the mouse click in the game window
 move		   : moves the snake
 check		   : checks the validity of each move
 plotbonusfruit : plots the bonus fruit randomly
 
 */

int HSload();
int loadmenu();
int mainmenu();
int mainmenuclick(const Position &p);
int HSdisplay();
int loadinstructions();
int loadcredits();
int exitmenu();
int exitwindowclick(const Position &p);
int loadgame();
int playgame();
int load();
int loadmap();
int plofruit();
int genrandom(int r);
int endgame();
int convert(int a);
int checkscore();
int gameoverclick(const Position &p);
int turn();
int gamewindowclick(const Position &p);
int move();
int check();
int plotbonusfruit();


// main program
int ApiMain()
{	
	HSload();
	menu.Open();
	loadmenu();
	mainmenu();
	return 0;
}

int HSload()
{
	ifstream in;
	in.open("scores.h");
	for(int i=0;i<5;i++)
		in>>HS[i];
	in.close();
	return 0;
}

int loadmenu()
{
	
	//load the images on the opening screen
	
	background.Load(".xpm");
	background.SetPosition(Position(,));
	
	newgame.Load(".xpm");
	newgame.SetPosition(Position(,));
	
	highscore.Load(".xpm");
	highscore.SetPosition(Position(,));
	
	help.Load(".xpm");
	help.SetPosition(Position(,));
	
	credit.Load(".xpm");
	credit.SetPosition(Position(,));
	
	quit.Load(".xpm");
	exit.SetPosition(Position(,));
	
	back.Load(".xpm");
	back.SetPosition(Position(,));
	
	return 0;
}

int mainmenu()
{
	
	background.Draw();
	newgame.Draw();
	highscore.Draw();
	help.Draw();
	credit.Draw();
	quit.Draw();
	menu.SetMouseClickCallback(mainmenuclick);
	return 0;
}

int mainmenuclick(const Position &p)
{
	if(newgame.isinside(p))
	{
		menu.close();
	    loadgame();
	}
	else if(highscore.isinside(p))
	{
		HSdisplay();
	}
	else if(help.isinside(p))
	{
		loadinstructions();
	}
	else if(credit.isinside(p))
	{
		loadcredits();
	}
	else if(quit.isinside(p))
	{
		menu.close();
		exitmenu();
	}
	else if(back.isinside(p))
	{
		mainmenu();
	}
	return 0;
}

int HSdisplay()
{
	// code to display the highscores 
	back.Draw();
	return 0;
}

int loadinstructions()
{
	// havent set the orientation of the bitmap yet
	instructions.Load(".xpm");
	instructions.SetPosition(Position(,));
	instructions.Draw();
	back.Draw();
	return 0;
}

int loadcredits()
{
	// havent set the orientation of the bitmap yet
	credits.Load(".xpm");
	credits.Setposition(Position(,));
	credits.Draw();
	back.Draw();
	return 0;
}

int exitmenu()
{
	exitwindow.Open();
	exitwindow.RenderText(Position(,),Position(,),"You really want to exit?", Black);
	yes.Load(".xpm");
	yes.SetPosition(Position(,));
	yes.Draw();
	no.Load(".xpm");
	no.SetPosition(Position(,));
	no.Draw();
	exitwindow.SetMouseClickCallback(exitwindowclick);
	return 0;
	
}

int exitwindowclick(const Position &p)
{
	
	//function to exit from the game on mouse click
	
	if(yes.isinside(p))
	{
		exit(0);
	}
	else if(no.isinside(p))
	{
		exitwindow.Close();
		mainmenu();
	}
	
	return 0;
}

int loadgame()
{
	game.Open();
	head.Load(".xpm");
	body.Load(".xpm");
	wall.Load(".xpm");
	bonusfruit.Load(".xpm");
	life.Load(".xpm");
	nolife.Load(".xpm");
	score=0;
	levelscore=0;
	length=4;
	level=1;
	lives=3;
	lengthinc=0;
		
	//starting the game
	playgame();
	return 0;
}

int playgame()
{
	load();
	game.SetMouseClickCallback(gamewindowclick);
	game.SetTimerCallback(timerClick);
	game.StartTimer(delay);

}

int timerClick()
{
	//call the following functions repeatedly after a certain time interval
	distanceCount++;
	if(bonusFruitPresence)
		handleBonusFruit();
	move();
	return 0;
}

int gamewindowclick(const Position &p)
{
	//if the direction of the snake is up or down then to change it, following code works:
	if(direc=='U'|| direc=='D')
	{
		//if the mouse click is to the left of the snake, then turn left
		if(p.GetXDistance()*2<snake[0].x)
		{
			direc='L';
		}
		//if the mouse click is to the right of the snake, then turn right
		else if(p.GetXDistance()*2>snake[0].x)
		{
			direc='R';
		}
	}
	//if the direction of the snake is left or right then to change it, following code works:
	else
	{
		//if the mouse click is above the snake, then turn upwards
		if(p.GetYDistance()*2<snake[0].y)
		{
			direc='U';
		}
		//if the mouse click is below the snake, then turn downwards 
		else if(p.GetYDistance()*2>snake[0].y)
		{
			direc='D';
		}
	}
	//turn the snake in the new direction
	turn();
	//move the snake
	move();
	return 0;
}


int load()
{
	// loading the next level check if game is over
	if (level>5) {
		// write the endgame function
		endgame();
		return 0;
	}
	loadmap();
	plotfruit();
	direc='R';
	turn();
	return 0;
	
}

int turn()
{
	//switches according to the newly assigned direction
	switch(direc)
	{
			//changes the image for head and tail as per the new direction
		case 'U' : head.Load("headU.xpm");
			break;
		case 'D' : head.Load("headD.xpm");
			break;
		case 'R' : head.Load("headR.xpm");
			break;
		case 'L' : head.Load("headL.xpm");
			break;
	}
	return 0;
}

int move()
{
	//Store the initial co-ordinates of head
	int tempX1,tempX2,tempY1,tempY2;	
	tempX1=snake[0].x; tempY1=snake[0].y;
	tempX2=snake[1].x; tempY2=snake[1].y;
	//"for" loop to transfer the co-ordinates of a body part to the next body part
	for(int i=1;(i<length-1);i++)
	{
		snake[i].x=tempX1; snake[i].y=tempY1;
		tempX1=tempX2; tempY1=tempY2;
		tempX2=snake[i+1].x; tempY2=snake[i+1].y;
	}
	
	if(lengthinc)
	{
		snake[length-1].x=snake[length-2].x;
		snake[length-1].y=snake[length-2].y;
		lengthinc=0;
	}
	else
	{
		snake[length-1].x=tempX1;snake[length-1].y=tempY1;
	}
	
	switch(direc)
	{
			//if snake goes upwards
		case 'U' : snake[0].y-=1;
			break;
			//if snake goes downwards
		case 'D' : snake[0].y+=1;
			break;
			//if snake goes left
		case 'L' : snake[0].x-=1;
			break;
			//if snake goes right
		case 'R' : snake[0].x+=1;
			break;
	}
	
	
	
	//generate new coordinates for the snake to come from left of screen to right of screen
	//generate new coordinates for the snake to come from top of screen to bottom of the screen
	
	if(snake[0].x==20)
		snake[0].x=0;
	else if(snake[0].x==-1)
		snake[0].x=19;
	if(snake[0].y==20)
		snake[0].y=0;	
	else if(snake[0].y==-1)
		snake[0].y=19;
	
	//cout<<snake[0][1]<<" "<<snake[1][1]<<" "<<snake[2][1] << endl; //used for debugging while checking the program
	//cout << subLevel;
	
	int chk=check();
	int bodylength=(chk==1)?length-2:length;
	//Setting new position for image of head
	//head.Erase();
	head.SetPosition(Position((float)(snake[0].x)/2,((float)snake[0].y)/2));
	head.Draw();
	
	//Setting new position for image of body
	body.Erase();
	for(int i=1; i<bodylength; i++)
	{
		body.SetPosition(Position((float)(snake[i].x)/2,(float)(snake[i].y)/2));
		body.Draw();
	}
	return 0;
}

int check()
{
	/*
	 map[][]=1 means there is a wall on that position
	 map[][]=2 means there is a bonus fruit on that position
	 map[][]=3 means there is a fruit on that position
	 */
	
	
	//The snake collides with wall
	if(map[snake[0].x][snake[0].y]==1)
	{
		if(lives!=0)
		{
			lives--;
			length=0;
			delay=250;
			levelscore=0;
			//scorePane('L');
			playgame();
		}
		else
		{
			//level=11;
			//restart the game
			//w.StopTimer();
			endgame;
		}
		return 0;
	}
	
	//The snake eats the fruit	
	else if(map[snake[0].x][snake[0].y]==3)
	{
		map[snake[0].x][snake[0].y]=0;
		//if the number of fruits eaten is less than 10
		if(length<20)
		{
			//change the sublevel(that is the no. of fruits eaten)
			length+=2;
			lengthinc=1;
			
			//adding scores
			levelscore+=20;
			
			// needs update
			//plotting bonus fruit as per the case
			if(length==10 || length==18)
			{
				plotbonusfruit();
				bonusFruitPresence=true;
			}
			//plot the next fruit
			plotfruit();
			return 1;
		}
		
		//if number of the fruits eaten is 10 
		else
		{
			if(level==5)
				gameOver();
			else
			{
				//go to the next level
				level++;
				//snake comes back to initial length
				length=0;
				levelscore+=20;
				score+=levelscore;
				levelScore=0;
				
				game.StopTimer();
				delay=250;
				
				//start the next level
				playgame();
			}
			return 0;
		} 
	}
	else if(map[snake[0].x][snake[0].y]==2)
	{
		levelscore+=50;
		map[xbonusfruit][ybonusfruit]=0;
		return 0;
	}
	//The snake collides with the body
	else
	{
		for(int i=1; i<length; i++)
		{
			//Co-ordinates of head and a body part become same
			if(snake[0].x==snake[i].x && snake[0].y==snake[i].y)
			{
				//game over
				if(lives!=0)
				{
					lives--;
					//scorePane('L');
					length=4;
					delay=250;
					levelScore=0;
					playGame();
				}
				else
				{
					//level=11;
					//w.StopTimer();
					endgame();
					//restart the game
					//playGame();
				}
				return 0;
			}
		}
	}
	
}



int loadmap()
{
	char a[6]="map1.h";
	FILE *fp;
	a[3]=(char)(48+level);
	fp=fopen(a,"r");
		
		
	//load the wall where map array contains '1'
	// need to update this
		
		for(int i=0; i<; i++)
		{
			for(int j=0; j<; j++)
			{
				fscanf(fp, "%d", &map[i][j]);
				if(map[i][j]==1)
				{
					wall.SetPosition(Position((float), (float)));
					wall.Draw();
				}
			}
		}
		
		//initial position of the snake as per the level
		for(int i=0; i<4;i++)
		{
				
			fscanf(fp, "%d", &snake[i].x);
			fscanf(fp, "%d", &snake[i].y);
		}
		
		fclose(fp);
		
		//drawing the snake at the initial co-ordinates
	head.SetPosition(Position((float),(float)));
	head.Draw();
	body.SetPosition(Position((float),(float)));
	body.Draw();
	body.SetPosition(Position((float),(float)));
	body.Draw();
	body.SetPosition(Position((float),(float)));
	body.Draw();
	
	retun 0;
}


int plotfruit()
{
	int flag=1;
	while(flag==1)	
	{
		flag=0;
		// needs update
		//generating random co-ordinates for the fruit
		xfruit=genrandom(20);
		yfruit=genrandom(20);
		//if the co-ordinates generated lie on wall or snake or bonus fruit
		//checking for wall and bonus fruit
		if(map[xfruit][yfruit]==1 || map[xfruit][yfruit]==2)
		{
			flag=1;
		}
		//checking for snake
		else
		{
			for(int i=0; i<length; i++)
			{
				if(snake[i][0]==xfruit && snake[i][1]==yfruit)
					flag=1;
			}
		}
	}	//if flag=1, generate another pair of co-ordinates
	
	//setting new fruit co-ordinate to 3
	map[xfruit][yfruit]=3;
	
	//random fruit type
	int fruitRand=genrandom(3);
	string a=" ";
	string c=".xpm";
	string imageF =a+(char)(48+fruitRand)+c;
	//loading new fruit
	fruit.Load(imageF);
	fruit.SetPosition(Position((float)xfruit/2,(float)yfruit/2));
	fruit.Draw();
		
	return 0;
}  

int plotbonusfruit()
{
	int flag=1;
	while(flag==1)
	{	
		flag=0;
		
		//generating random co-ordinates for the fruit
		xBonusFruit=genrandom(20);
		yBonusFruit=genrandom(20);
		
		//if the co-ordinates generated lie on wall or snake
		//checking for wall
		if(map[xbonusfruit][ybonusfruit]==1 || map[xbonusfruit][ybonusfruit]==3)
		{
			flag=1;
		}
		//checking for snake
		else
		{
			for(int i=0; i<length; i++)
			{
				if(snake[i].x==xbonusfruit && snake[i].y==ybonusfruit)
					flag=1;
			}
		}
	}while(flag==1);
	
	map[xbonusfruit][ybonusfruit]=2;
	
	bonusfruit.SetPosition(Position((float)xbonusfruit/2,(float)ybonusfruit/2));
	bonusfruit.Draw();
	
	return 0;
}


int genrandom(int r)
{
	srand(GetMilliseconds());
	
  	return rand()%r;
}

int endgame()
{	
	// needs update
	int rank=checkscore();
	game.StopTimer();
	//w.Close();
	gameover.Open();
	go.Load(".xpm");
	go.SetPosition(Position(,));
	go.Draw();
	if(rank<0)
	{
		go.RenderText(Position(,),Position(,),"You couldn't make it to the highscores.", Red);
	}
	else
	{
		go.RenderText(Position(,),Position(,),"Congrats! You made it to the highscores!!!", Green);
		convert(rank);
		go.RenderText(Position(,),Position(,), str, Red);
		convert(score);
		go.RenderText(Position(,),Position(,), str, Blue);
	}
	gameoover.SetMouseClickCallback(gameoverclick);
	gameover.RenderText(Position(,),Position(,),"Have Another Go?", Black);
	BitMap y(gameover);
	BitMap n(gameover);
	y.Load(".xpm");
	y.SetPosition(Position(,));
	n.Load(".xpm");
	n.SetPosition(Position(,));
	y.Draw();
	n.Draw();
	return 0;
}

int convert(int a)
{
	
	int i=0, b=a;
	while(b!=0)
	{
		i++;
		b=b/10;
	}
	str[i]='\0';	
	if(a==0)
	{
		str[0]='0';
		i=1;
	}
	else
	{
		while(a!=0)
		{
			str[i-1]=(char)((a%10)+48);
			a=a/10;
			i--;
		}
	}
	return 0;
}
	

int checkscore()
{
	int i=0, flag=0;
	for(i=0;i<5;i++)
	{
		if(score>HS[i])
		{
			for(int j=4;j>i;j--)
			{
				HS[j]=HS[j-1];
				lvlReached[j]=lvlReached[j-1];
			}
			HS[i]=score;
			flag=1;
			ofstream write;
			write.open("scores.h",ios::out | ios::trunc);
			for(int k=0;k<5;k++)
				write<<HS[k]<<"\n";
			write.close();
		}
		if(flag==1) break;
	}
	if(flag==1)
		return i+1;
	else 
		return -1;
}

int gameoverclick(const Position &p)
{
	
	if(y.isinside(p))
	{
		gameover.Close();
		game.Close();
		loadmenu();
	}
	else if(n.isinside(p))
	{
		gameover.Close();
		exit(0);
	}
	return 0;
}













