
// get next nonwhite character from file .we have to pass the pointer to that file
char mygetc(FILE*fp){
	char c;
	while(!feof(fp)){
		if(!isspace(c=fgetc(fp))) return c;
	}
}

//__________________________________________________________________________________________________________________________________________________________________
//following function rewinds internal byte position by -1
void setbf(FILE*fp){
	fseek(fp,-1,SEEK_CUR);
}


//__________________________________________________________________________________________________________________________________________________________________
//following function positions internal byte position just before a non-white character
void setright(FILE*fp){
	mygetc(fp);
	setbf(fp);
}	

//__________________________________________________________________________________________________________________________________________________________________
// function to reset values to "DEFAULT" for every cycle
void reset(){
	//all the flags
	f.flag_x=0;	
	f.flag_m=0;	f.flag_M=0;	f.flag_inf=0;
	f.flag_A=0;
	
	//now some default vals
	f.x1=0;f.x2=0;
	f.no_m=0;		f.no_M=0;		f.no_inf=0;
	f.no_T=0;		f.no_N=0;
	f.scale_y=2.0;
	strcpy(f.fcolor,"Black");	f.g_color=Black;
}

//__________________________________________________________________________________________________________________________________________________________________

//function for validating data after reading whether it is sufficient and is correct form as expected and giving a flag whether to plot it or not 


int validate(){int flag_plot=1;cout<<"VALIDATING FUNCTION no:"<<z<<"\n";int i=0;int temp;			//this is the flag to decide whwther to plot or not


	if(f.flag_x==0 ){cout<<"\nx limits not given properly ,skipping the function";	return 0;}					//check x limits given or not
	if(f.flag_x==1 && f.x1>=f.x2){cout<<"\nx limits not given properly ,skipping the function";return 0;}
	
	
	temp=0;					
	for(i=0;i<f.no_T;i++){if(f.T[i]<f.x1 ||f.T[i]>f.x2)  temp++;}						//check tangent points
	if(temp>0)cout<<"\nsome of tangent points out of given x limits	";
	
	temp=0;					
	for(i=0;i<f.no_N;i++){if(f.N[i]<f.x1 ||f.N[i]>f.x2)  temp++;}						//check normal points
	if(temp>0)cout<<"\nsome of normal points out of given x limits	";	
	
	
	
	
	if(f.flag_A==1){if(f.A1>=f.A2 ||f.A1<f.x1||f.A2>f.x2){	cout<<"\narea limits improper.";f.flag_A=0;}}				//check area limits
	
	if((strcmp(f.fcolor,"Black")*strcmp(f.fcolor,"Blue")*strcmp(f.fcolor,"Red")*strcmp(f.fcolor,"Yellow")*strcmp(f.fcolor,"Green")*strcmp(f.fcolor,"Cyan")*strcmp(f.fcolor,"Magenta"))!=0){cout<<"\ncolor code not acceptable.Default color black used";}
	
	else if(strcmp(f.fcolor,"Black")==0){f.g_color=Black;}
	else if(strcmp(f.fcolor,"Red")==0){f.g_color=Red;}
	else if(strcmp(f.fcolor,"Yellow")==0){f.g_color=Yellow;}
	else if(strcmp(f.fcolor,"Green")==0){f.g_color=Green;}
	else if(strcmp(f.fcolor,"Cyan")==0){f.g_color=Cyan;}
	else if(strcmp(f.fcolor,"Blue")==0){f.g_color=Blue;}
	else if(strcmp(f.fcolor,"Magenta")==0){f.g_color=Magenta;}
	
	return 1;				
}


//_________________________________________________________________________________________________________________________________________________________________

//function to parse 
int parseit(FunctionParser fparser){
	int res = fparser.Parse(f.expression, "x");
	
	if(res>=0){return 0;}
	
	int i=0;float step;
	step=(f.x2-f.x1)/999;float max,min;
	
	 double vals[] = { 0 };
	 
	for(i=0;i<1000;i++){
		vals[0]=f.plotx[i]=f.x1+i*step;
		f.ploty[i]=fparser.Eval(vals);
		if(i==0){max=min=f.ploty[i];}
		else { 
			if (f.ploty[i]>max){max=f.ploty[i];}
			else if(f.ploty[i]<min){min=f.ploty[i];}
		}
		
		//if(i%100==0)cout<<i<<"\t\t";             //ashish debug
	}
	
	f.absmax=max;
	f.absmin=min;
	return 1;
}

float eval(float y,FunctionParser fparser){
	int res = fparser.Parse(f.expression, "x");
	//cout<<"got here"     ;    //ashish
	double vals[] = { 0 };
	vals[0]=y;
	y=fparser.Eval(vals);  
	return y;	
}

int near(float x){
	float step=(f.x2-f.x1)/999;
	int gif ;gif=(x-f.x1)/step;
	if(gif>=998)return gif;
	else if(x-f.plotx[gif]<=0.5) return gif;
	else return (gif+1);
}	 

	
	
	
	
				
			
	
//debug on developing stage
void debug(int j){int i=0;
	cout<<"\n**************************************************************************************************************************\n\n";
	
	cout<<"\nfunc no: "<<z<<"\nexpression is :"<<f.expression;cout<<"\nb/w "<<f.x1<<"  &  "<<f.x2<<endl;
	//cout<<"\ncolor :"<<f.fcolor<<"\n M-"<<f.flag_M<<"\t\tm-"<<f.flag_m<<"\t\tI-"<<f.flag_inf<<endl;
	
	if(f.no_T>0){cout<<f.no_T <<"tangents at :";
		for(i=0;i<f.no_T;i++){
			cout<<f.T[i]<<"\t\t";
		}
	}
	else cout<<"NO TANGENTS\n";
	cout<<endl;
	
	if(f.no_N>0){cout<<f.no_N <<"normals at :";
		for(i=0;i<f.no_N;i++){
			cout<<f.N[i]<<"\t\t";
		}
		cout<<endl;
	}
	else cout<<"NO NORMALS\n";
	cout<<endl;
	
	if(f.flag_A==1){cout<<"AREA  b/w  :"<<f.A1<<" & "<<f.A2<<"\n";}
	else{cout<<"NO AREA to be calculated\n";}
	
	// cout<<" SCALE set is :"<<f.scale_y<<endl;
	
	/*cout<<"checking near function \n";float x=1.6354;int p= near(x); cout<<"near pt of 1.6354 is f.x["<<p<<"]   :"<<f.plotx[p]<<"\nsurr pts are  :("<<f.plotx[p-1] <<", "<<f.ploty[p-1]<<")\t("<<f.plotx[p+1]<<", "<<f.ploty[p+1]<<")\n"; 
	*/
	
}
	
	
	

